commit 0fcb708f3eec9a99bb4d6610105394abb368b1c1
Author: Matej Zeman <zeman339@gmail.com>
Date:   Sun May 15 15:53:00 2022 +0200

    re #9846 Changed keyman devices, body devices views. Added Head devices view. Changed filtering of logs, ldlogs, body devices, head devices and keyman devices. Changed HTML tables style and few labels.

diff --git a/server/sql_app/api/auth.py b/server/sql_app/api/auth.py
index a66baca..425d8ba 100644
--- a/server/sql_app/api/auth.py
+++ b/server/sql_app/api/auth.py
@@ -50,14 +50,23 @@ fake_users_db = {
 
 
 def verify_password(plain_password, hashed_password):
+    """
+    Verifies plain text password with hashed password
+    """
     return pwd_context.verify(plain_password, hashed_password)
 
 
 def get_hash_password(password):
+    """
+    Returns hashed password
+    """
     return pwd_context.hash(password)
 
 
 def auth_user(db, username: str, password: str):
+    """
+    Determines if given password belongs to user with given username
+    """
     user = crud.find_user(db, username)
     if not user:
         return None
diff --git a/server/sql_app/api/bodydevices_web.py b/server/sql_app/api/bodydevices_web.py
index 48b345e..b00c8d8 100644
--- a/server/sql_app/api/bodydevices_web.py
+++ b/server/sql_app/api/bodydevices_web.py
@@ -33,111 +33,139 @@ def get_db():
 async def read_devices(request: Request, skip: int = 0, limit: int = 100, db: Session = Depends(get_db),
                        Authorize: AuthJWT = Depends()):
     """
-    Returns template with all body devices and its current states
+    Returns template with all body devices and necessary attributes
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
 
+    device_dict = []
     devices = crud.get_body_devices(db, skip=skip, limit=limit)
-    statuses = []
-    # adding state for each device in list
-    for i in range(0, len(devices)):
-        statuses.append(devices[i].b_logs[len(devices[i].b_logs) - 1].status)
+    teams = crud.get_teams(db, skip=skip, limit=limit)
+    for dev in devices:
+        lic = crud.get_license(db, dev.license_id)
+        device_dict.append({"device": dev, "license": lic, "log": dev.b_logs[len(dev.b_logs) - 1]})
     licenses = crud.get_licenses(db, skip=skip, limit=limit)
     if current_user == "admin":
-        return templates.TemplateResponse("body_devices.html", {"request": request, "devs": len(devices), "devices": devices,
-                                                           "statuses": statuses, "licenses": licenses, "user": current_user})
+        return templates.TemplateResponse("body_devices.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
     else:
         current_user = "guest"
-        return templates.TemplateResponse("body_devices_normal.html", {"request": request, "devs": len(devices), "devices": devices,
-                                                           "statuses": statuses, "licenses": licenses, "user": current_user})
+        return templates.TemplateResponse("body_devices_normal.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
 
 
 @body_device_web.post("/body-devices-web", response_class=HTMLResponse)
-async def filter_devices(request: Request, skip: int = 0, limit: int = 100, lic: str = Form("all"),
+async def filter_devices(request: Request, skip: int = 0, limit: int = 100,
+                         body_id: str = Form("all"), lic_id: str = Form("all"), team: str = Form("all"),
                          db: Session = Depends(get_db), Authorize: AuthJWT = Depends()):
     """
-    Endpoint used for filtering body devices by license. returns html template with only
-    body devices that has assigned license defined by user input
+    Endpoint used for filtering body devices by user given inputs. returns html template with only
+    body devices that has attributes defined by user input
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
-    devices = crud.get_body_devices(db, skip=skip, limit=limit)
-    def_devices = []
+    device_dict = []
+    devices_f = crud.get_filtered_bodydevices(db, body_id, lic_id, team)
+    ids = []
+    for d in devices_f:
+        ids.append(d[0])
+    devices = crud.get_bodydevices_with_ids(db, ids)
+    teams = crud.get_teams(db, skip=skip, limit=limit)
     for dev in devices:
-        for l in dev.debug_licenses:
-            if dev not in def_devices and l.b_licenses.name == lic:
-                def_devices.append(dev)
-    # if input was default all
-    if lic == "all":
-        def_devices = devices
-    statuses = []
-    for i in range(0, len(def_devices)):
-        statuses.append(def_devices[i].b_logs[len(def_devices[i].b_logs) - 1].status)
+        lic = crud.get_license(db, dev.license_id)
+        device_dict.append({"device": dev, "license": lic, "log": dev.b_logs[len(dev.b_logs) - 1]})
     licenses = crud.get_licenses(db, skip=skip, limit=limit)
     if current_user == "admin":
-        return templates.TemplateResponse("body_devices.html",
-                                          {"request": request, "devs": len(def_devices), "devices": def_devices,
-                                           "statuses": statuses, "licenses": licenses, "user": current_user})
+        return templates.TemplateResponse("body_devices.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
     else:
         current_user = "guest"
-        return templates.TemplateResponse("body_devices_normal.html",
-                                          {"request": request, "devs": len(def_devices), "devices": def_devices,
-                                           "statuses": statuses, "licenses": licenses, "user": current_user})
+        return templates.TemplateResponse("body_devices_normal.html", {"request": request, "devices": device_dict,
+                                                                       "devs": devices, "teams": teams,
+                                                                       "licenses": licenses,
+                                                                       "user": current_user})
 
 
 @body_device_web.get("/body-device-license/{device_id}", response_class=HTMLResponse)
 async def connect_dev_lic(request: Request, device_id: int, db: Session = Depends(get_db),
                           Authorize: AuthJWT = Depends()):
     """
-    Returns template with one body device and all available licenses that can be assigned to it.
+    Returns template with one body device and all available licenses that can be assigned to it. Plus available teams
+    that can be assigned to device, inventory number and comment text input for this device.
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
     if current_user != "admin":
         return RedirectResponse(url=f"/logs-web", status_code=303)
     device = crud.get_body_device(db, device_id)
-    dev_licenses = crud.get_bodydevice_license(db, device_id)
-    lic_names = []
-    dev_lics = []
-    for dev_lic in dev_licenses:
-        dev_lics.append(dev_lic.b_licenses)
-    for dev_lic in dev_licenses:
-        lic_names.append(dev_lic.b_licenses.name)
     licenses = crud.get_licenses(db, 0, 100)
     lic_left = []
     for lic in licenses:
-        if lic.name not in lic_names and lic not in lic_left:
+        if lic != device.license:
             lic_left.append(lic)
+    teams = crud.get_teams(db, 0, 100)
     return templates.TemplateResponse("body_device_license.html",
-                                      {"request": request, "device": device, "licenses": lic_left, "dev_lic": dev_lics})
+                                      {"request": request, "device": device, "licenses": lic_left, "teams": teams})
 
 
-@body_device_web.post("/body-devices-web/{device_id}")
+@body_device_web.post("/body-devices-web-lic/{device_id}")
 async def connect_post(device_id: int, lic: str = Form(...), db: Session = Depends(get_db),
                        Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for connecting body device with license. Adds entry to bodydevices_licenses
-    table and redirects to body-devices-web endpoint
+    Endpoint called from template from body_device_license.html template. Connects body device with license
+    and redirects to body-devices-web endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
     if current_user != "admin":
         return RedirectResponse(url=f"/logs-web", status_code=303)
-    crud.create_body_device_license(db, device_id, int(lic), datetime.now())
+    crud.update_bodydevice_license(db, device_id, int(lic))
     return RedirectResponse(url=f"/body-devices-web", status_code=303)
 
 
-@body_device_web.post("/body-devices-web-del/{device_id}")
-async def delete_post(device_id: int, b_lic: str = Form(...), db: Session = Depends(get_db),
+@body_device_web.post("/body-devices-web-team/{device_id}")
+async def delete_post(device_id: int, team_con: str = Form(...), db: Session = Depends(get_db),
                       Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for connecting body device with license. Adds entry to devices_licenses
-    table and redirects to body-devices-web endpoint
+    Endpoint called from template from body_device_license.html template, connects device with new team
+    and redirects to body-devices-web endpoint
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_bodydevice_team(db, device_id, int(team_con))
+    return RedirectResponse(url=f"/body-devices-web", status_code=303)
+
+
+@body_device_web.post("/body-devices-inv/{device_id}")
+async def device_inv(device_id: int, dev_inv: str = Form(...), db: Session = Depends(get_db),
+                     Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from template from body_device_license.html template, updates devices inventory number
+    and redirects to body-devices-web endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
     if current_user != "admin":
         return RedirectResponse(url=f"/logs-web", status_code=303)
-    crud.delete_bodydevice_license(db, device_id, int(b_lic))
-    return RedirectResponse(url=f"/body-devices-web", status_code=303)
\ No newline at end of file
+    crud.update_bodydevice_inv(db, device_id, dev_inv)
+    return RedirectResponse(url=f"/body-devices-web", status_code=303)
+
+
+@body_device_web.post("/body-devices-comm/{device_id}")
+async def device_inv(device_id: int, dev_com: str = Form(...), db: Session = Depends(get_db),
+                     Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from template from body_device_license.html template, updates devices comment
+    and redirects to body-devices-web endpoint
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_bodydevice_comm(db, device_id, dev_com)
+    return RedirectResponse(url=f"/body-devices-web", status_code=303)
diff --git a/server/sql_app/api/devices_web.py b/server/sql_app/api/devices_web.py
index 73fdf61..ff0f029 100644
--- a/server/sql_app/api/devices_web.py
+++ b/server/sql_app/api/devices_web.py
@@ -33,7 +33,7 @@ def get_db():
 async def read_devices(request: Request, skip: int = 0, limit: int = 100, db: Session = Depends(get_db),
                        Authorize: AuthJWT = Depends()):
     """
-    Returns template with all devices and its current states
+    Returns template with all devices and its necessary attributes
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
@@ -65,7 +65,7 @@ async def filter_devices(request: Request, skip: int = 0, limit: int = 100,
                          lic_id: str = Form("all"), team: str = Form("all"),
                          db: Session = Depends(get_db), Authorize: AuthJWT = Depends()):
     """
-    Endpoint used for filtering devices by license. returns html template with only
+    Endpoint used for filtering devices by user given inputs. returns html template with only
     devices that has assigned license defined by user input
     """
     Authorize.jwt_optional()
@@ -99,7 +99,8 @@ async def filter_devices(request: Request, skip: int = 0, limit: int = 100,
 async def connect_dev_lic(request: Request, device_id: int, db: Session = Depends(get_db),
                           Authorize: AuthJWT = Depends()):
     """
-    Returns template with one device and all available licenses that can be assigned to it.
+    Returns template with one device and all available licenses that can be assigned to it. Plus all teams that can
+    be assigned to device, inventory number text input and comment text input
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
@@ -128,7 +129,7 @@ async def connect_dev_lic(request: Request, device_id: int, db: Session = Depend
 async def connect_post(device_id: int, lic: str = Form(...), db: Session = Depends(get_db),
                        Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for connecting device with license. Adds entry to devices_licenses
+    Endpoint called from devicelicense.html template. Adds entry to devices_licenses
     table and redirects to devices-web endpoint
     """
     Authorize.jwt_optional()
@@ -143,8 +144,8 @@ async def connect_post(device_id: int, lic: str = Form(...), db: Session = Depen
 async def delete_post(device_id: int, lic_del: str = Form(...), db: Session = Depends(get_db),
                       Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for deleting device-license connection. Adds entry to bodydevices_licenses
-    table and redirects to devices-web endpoint
+    Endpoint called from devicelicense.html template for deleting device-license connection. Deletes entry in
+    bodydevices_licenses table and redirects to devices-web endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
@@ -153,12 +154,12 @@ async def delete_post(device_id: int, lic_del: str = Form(...), db: Session = De
     crud.delete_device_license(db, device_id, int(lic_del))
     return RedirectResponse(url=f"/devices-web", status_code=303)
 
+
 @device_web.post("/devices-web-team/{device_id}")
 async def dev_team_con(device_id: int, team_con: str = Form(...), db: Session = Depends(get_db),
-                      Authorize: AuthJWT = Depends()):
+                       Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for deleting device-license connection. Adds entry to bodydevices_licenses
-    table and redirects to devices-web endpoint
+    Endpoint called from devicelicense.html template, connects device with team and redirects to devices-web endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
@@ -167,12 +168,13 @@ async def dev_team_con(device_id: int, team_con: str = Form(...), db: Session =
     crud.update_device(db, device_id, team_con)
     return RedirectResponse(url=f"/devices-web", status_code=303)
 
+
 @device_web.post("/devices-web-inv/{device_id}")
 async def dev_inv_new(device_id: int, dev_inv: str = Form(...), db: Session = Depends(get_db),
                       Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for deleting device-license connection. Adds entry to bodydevices_licenses
-    table and redirects to devices-web endpoint
+    Endpoint called from template devicelicense.html, updates inventory number of device and redirects to devices-web
+    endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
@@ -181,12 +183,13 @@ async def dev_inv_new(device_id: int, dev_inv: str = Form(...), db: Session = De
     crud.update_device_inv(db, device_id, dev_inv)
     return RedirectResponse(url=f"/devices-web", status_code=303)
 
+
 @device_web.post("/devices-web-comment/{device_id}")
 async def dev_comm_new(device_id: int, dev_com: str = Form(...), db: Session = Depends(get_db),
-                      Authorize: AuthJWT = Depends()):
+                       Authorize: AuthJWT = Depends()):
     """
-    Endpoint called from template for deleting device-license connection. Adds entry to bodydevices_licenses
-    table and redirects to devices-web endpoint
+    Endpoint called from template devicelicense.html, updates comment of device and redirects to devices-web
+    endpoint
     """
     Authorize.jwt_optional()
     current_user = Authorize.get_jwt_subject()
diff --git a/server/sql_app/api/headdevices_web.py b/server/sql_app/api/headdevices_web.py
new file mode 100644
index 0000000..2e6452b
--- /dev/null
+++ b/server/sql_app/api/headdevices_web.py
@@ -0,0 +1,169 @@
+from datetime import datetime
+
+from fastapi import Depends, APIRouter, Form
+from fastapi import Request
+from fastapi.responses import HTMLResponse, RedirectResponse
+from fastapi.templating import Jinja2Templates
+from fastapi_jwt_auth import AuthJWT
+from pydantic import BaseModel
+from sqlalchemy.orm import Session
+from sql_app.api.auth import fake_users_db
+from sql_app import crud, models
+from ..database import SessionLocal, engine
+
+models.Base.metadata.create_all(bind=engine)
+
+# Path to html templates used in this file
+templates = Jinja2Templates(directory="templates/head_devices")
+
+# prefix used for all endpoints in this file
+head_device_web = APIRouter(prefix="")
+
+
+# Dependency
+def get_db():
+    db = SessionLocal()
+    try:
+        yield db
+    finally:
+        db.close()
+
+
+@head_device_web.get("/head-devices-web", response_class=HTMLResponse)
+async def read_devices(request: Request, skip: int = 0, limit: int = 100, db: Session = Depends(get_db),
+                       Authorize: AuthJWT = Depends()):
+    """
+    Returns template with all head devices and necessary attributes
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+
+    device_dict = []
+    devices = crud.get_head_devices(db, skip=skip, limit=limit)
+    teams = crud.get_teams(db, skip=skip, limit=limit)
+    for dev in devices:
+        lic = crud.get_license(db, dev.license_id)
+        device_dict.append({"device": dev, "license": lic, "log": dev.h_logs[len(dev.h_logs) - 1]})
+    licenses = crud.get_licenses(db, skip=skip, limit=limit)
+    if current_user == "admin":
+        return templates.TemplateResponse("head_devices.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
+    else:
+        current_user = "guest"
+        return templates.TemplateResponse("head_devices_normal.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
+
+
+@head_device_web.post("/head-devices-web", response_class=HTMLResponse)
+async def filter_devices(request: Request, skip: int = 0, limit: int = 100,
+                         body_id: str = Form("all"), lic_id: str = Form("all"), team: str = Form("all"),
+                         db: Session = Depends(get_db), Authorize: AuthJWT = Depends()):
+    """
+    Endpoint used for filtering head devices by user given inputs. returns html template with only
+    head devices that has attributes defined by user input
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    device_dict = []
+    devices_f = crud.get_filtered_headdevices(db, body_id, lic_id, team)
+    ids = []
+    for d in devices_f:
+        ids.append(d[0])
+    devices = crud.get_headdevices_with_ids(db, ids)
+    teams = crud.get_teams(db, skip=skip, limit=limit)
+    for dev in devices:
+        lic = crud.get_license(db, dev.license_id)
+        device_dict.append({"device": dev, "license": lic, "log": dev.h_logs[len(dev.h_logs) - 1]})
+    licenses = crud.get_licenses(db, skip=skip, limit=limit)
+    if current_user == "admin":
+        return templates.TemplateResponse("head_devices.html", {"request": request, "devices": device_dict,
+                                                                "devs": devices, "teams": teams, "licenses": licenses,
+                                                                "user": current_user})
+    else:
+        current_user = "guest"
+        return templates.TemplateResponse("head_devices_normal.html", {"request": request, "devices": device_dict,
+                                                                       "devs": devices, "teams": teams,
+                                                                       "licenses": licenses,
+                                                                       "user": current_user})
+
+
+@head_device_web.get("/head-device-license/{device_id}", response_class=HTMLResponse)
+async def connect_dev_lic(request: Request, device_id: int, db: Session = Depends(get_db),
+                          Authorize: AuthJWT = Depends()):
+    """
+    Returns template with one head device and all available licenses that can be assigned to it, plus team and comment
+    and inventory number inputs.
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    device = crud.get_head_device(db, device_id)
+    licenses = crud.get_licenses(db, 0, 100)
+    lic_left = []
+    for lic in licenses:
+        if lic != device.license:
+            lic_left.append(lic)
+    teams = crud.get_teams(db, 0, 100)
+    return templates.TemplateResponse("headlicense.html",
+                                      {"request": request, "device": device, "licenses": lic_left, "teams": teams})
+
+
+@head_device_web.post("/head-devices-web-lic/{device_id}")
+async def connect_post(device_id: int, lic: str = Form(...), db: Session = Depends(get_db),
+                       Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from template for connecting head device with license and redirects to head-devices-web endpoint
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_headdevice_license(db, device_id, int(lic))
+    return RedirectResponse(url=f"/head-devices-web", status_code=303)
+
+
+@head_device_web.post("/head-devices-web-team/{device_id}")
+async def delete_post(device_id: int, team_con: str = Form(...), db: Session = Depends(get_db),
+                      Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from template for connecting head device with team and redirects to body-devices-web endpoint
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_headdevice_team(db, device_id, int(team_con))
+    return RedirectResponse(url=f"/head-devices-web", status_code=303)
+
+
+@head_device_web.post("/head-devices-inv/{device_id}")
+async def device_inv(device_id: int, dev_inv: str = Form(...), db: Session = Depends(get_db),
+                     Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from within from headlicense.html template. Changes head devices inventory number with new one
+    given from user
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_headdevice_inv(db, device_id, dev_inv)
+    return RedirectResponse(url=f"/head-devices-web", status_code=303)
+
+
+@head_device_web.post("/head-devices-comm/{device_id}")
+async def device_inv(device_id: int, dev_com: str = Form(...), db: Session = Depends(get_db),
+                     Authorize: AuthJWT = Depends()):
+    """
+    Endpoint called from within from headlicense.html template. Changes head devices comment with new one
+    given from user
+    """
+    Authorize.jwt_optional()
+    current_user = Authorize.get_jwt_subject()
+    if current_user != "admin":
+        return RedirectResponse(url=f"/logs-web", status_code=303)
+    crud.update_headdevice_comm(db, device_id, dev_com)
+    return RedirectResponse(url=f"/head-devices-web", status_code=303)
\ No newline at end of file
